﻿// <auto-generated />
using ApelsinkaBot.DAL.Context;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace ApelsinkaBot.DAL.Migrations
{
    [DbContext(typeof(ApelsinkaDBContext))]
    [Migration("20220630223301_Add_starting_flag")]
    partial class Add_starting_flag
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.1")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.BotInfo", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<int>("Id"));

                    b.Property<bool>("IsStarted")
                        .HasColumnType("boolean")
                        .HasColumnName("is_started");

                    b.Property<string>("Name")
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.Property<string>("TelegramUsername")
                        .HasColumnType("text")
                        .HasColumnName("telegram_username");

                    b.Property<string>("Token")
                        .HasColumnType("text")
                        .HasColumnName("token");

                    b.Property<int>("UserId")
                        .HasColumnType("integer")
                        .HasColumnName("user_id");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("bots", (string)null);
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.Notification", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<int>("Id"));

                    b.Property<int>("BotId")
                        .HasColumnType("integer")
                        .HasColumnName("bot_id");

                    b.Property<long>("Frequency")
                        .HasColumnType("bigint")
                        .HasColumnName("frequency");

                    b.Property<string>("Name")
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.Property<int>("ServiceId")
                        .HasColumnType("integer")
                        .HasColumnName("service_id");

                    b.HasKey("Id");

                    b.HasIndex("BotId");

                    b.HasIndex("ServiceId");

                    b.ToTable("notifications", (string)null);
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.Service", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<int>("Id"));

                    b.Property<string>("Name")
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.HasKey("Id");

                    b.ToTable("services", (string)null);
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.Survey", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<int>("Id"));

                    b.Property<int>("BotId")
                        .HasColumnType("integer")
                        .HasColumnName("bot_id");

                    b.Property<int>("FirstSurveyPointId")
                        .HasColumnType("integer")
                        .HasColumnName("first_point_id");

                    b.Property<string>("Name")
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.HasKey("Id");

                    b.HasIndex("BotId");

                    b.HasIndex("FirstSurveyPointId");

                    b.ToTable("surveys", (string)null);
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.SurveyConnection", b =>
                {
                    b.Property<int>("ParentSurveyPointId")
                        .HasColumnType("integer")
                        .HasColumnName("parent_id");

                    b.Property<int>("SurveyPointId")
                        .HasColumnType("integer")
                        .HasColumnName("survey_point_id");

                    b.HasIndex("ParentSurveyPointId");

                    b.HasIndex("SurveyPointId");

                    b.ToTable("survey_connection", (string)null);
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.SurveyPoint", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<int>("Id"));

                    b.Property<string>("SurveyText")
                        .HasColumnType("text")
                        .HasColumnName("survey_text");

                    b.Property<string>("Type")
                        .HasColumnType("text")
                        .HasColumnName("type");

                    b.HasKey("Id");

                    b.ToTable("survey_points", (string)null);
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.User", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<int>("Id"));

                    b.Property<string>("PhoneNumber")
                        .HasColumnType("text")
                        .HasColumnName("phone_number");

                    b.Property<long>("TelegramId")
                        .HasColumnType("bigint")
                        .HasColumnName("telegram_id");

                    b.HasKey("Id");

                    b.ToTable("users", (string)null);
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.BotInfo", b =>
                {
                    b.HasOne("ApelsinkaBot.DAL.Entities.User", "User")
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("User");
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.Notification", b =>
                {
                    b.HasOne("ApelsinkaBot.DAL.Entities.BotInfo", "Bot")
                        .WithMany()
                        .HasForeignKey("BotId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("ApelsinkaBot.DAL.Entities.Service", "Service")
                        .WithMany()
                        .HasForeignKey("ServiceId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Bot");

                    b.Navigation("Service");
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.Survey", b =>
                {
                    b.HasOne("ApelsinkaBot.DAL.Entities.BotInfo", "Bot")
                        .WithMany()
                        .HasForeignKey("BotId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("ApelsinkaBot.DAL.Entities.SurveyPoint", "FirstSurveyPoint")
                        .WithMany()
                        .HasForeignKey("FirstSurveyPointId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Bot");

                    b.Navigation("FirstSurveyPoint");
                });

            modelBuilder.Entity("ApelsinkaBot.DAL.Entities.SurveyConnection", b =>
                {
                    b.HasOne("ApelsinkaBot.DAL.Entities.SurveyPoint", "ParentSurveyPoint")
                        .WithMany()
                        .HasForeignKey("ParentSurveyPointId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("ApelsinkaBot.DAL.Entities.SurveyPoint", "SurveyPoint")
                        .WithMany()
                        .HasForeignKey("SurveyPointId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("ParentSurveyPoint");

                    b.Navigation("SurveyPoint");
                });
#pragma warning restore 612, 618
        }
    }
}
